<template>
  <rui-dropdown block select-like>
    <template #caption>
      <div v-if="selectedPreset">
        <svg v-bind="svgAttributes">
          <g :stroke="`rgba(${selectedPreset.stroke})`"
             :style="selectedPreset.strokeStyle ? strokeStylePresets[selectedPreset.strokeStyle].style(selectedPreset.width) : ''">
            <rect v-bind="rectAttributes"
                  :fill="`rgba(${selectedPreset.fill})`"
                  :stroke-width="`${selectedPreset.width}px`" />
            <line v-bind="lineAttributes"
                  :stroke-width="`${selectedPreset.width}px`" />
          </g>
        </svg>
        {{ $t(selectedPreset.i18n) }}
      </div>
      <div v-else>{{ $t('js.color_preset.no_preset_selected') }}</div>
    </template>

    <rui-menu-item v-for="(preset, index) in colorPresets"
                   :key="index"
                   @click="select(preset)">
      <div>
        <svg v-bind="svgAttributes">
          <g :stroke="`rgba(${preset.stroke})`"
             :style="preset.strokeStyle ? strokeStylePresets[preset.strokeStyle].style(preset.width) : ''">
            <rect v-bind="rectAttributes"
                  :fill="`rgba(${preset.fill})`"
                  :stroke-width="`${preset.width}px`" />
            <line v-bind="lineAttributes"
                  :stroke-width="`${preset.width}px`" />
          </g>
        </svg>
        {{ $t(preset.i18n) }}
      </div>
    </rui-menu-item>
  </rui-dropdown>
</template>

<script>
import RuiDropdown from '@experiments-labs/rise_ui/src/components/Dropdown/Dropdown.vue'
import RuiMenuItem from '@experiments-labs/rise_ui/src/components/Menu/MenuItem.vue'

import strokeStylePresets from '../../../../strokeStylePresets'
import colorPresets from '../../../../colorPresets'

export default {
  name: 'GpaPathColorPresets',
  emits: [
    'choose',
  ],
  components: { RuiMenuItem, RuiDropdown },
  props: {
    selectedValues: { required: false, type: Object, default: () => ({}) },
  },
  data () {
    return {
      strokeStylePresets,
      colorPresets,
      rectAttributes: {
        width: '22.5',
        height: '10',
        x: '5',
        y: '2.5',
      },
      lineAttributes: {
        x1: '32.5',
        x2: '45',
        y1: '7',
        y2: '7',
      },
      svgAttributes: {
        xmlns: 'http://www.w3.org/2000/svg',
        width: '50',
        height: '15',
        viewBox: '0 0 50 15',
        class: '-checked-background',
      },
    }
  },
  computed: {
    selectedPreset () {
      return colorPresets.find((p) => {
        return (p.width === this.selectedValues.strokeWidth)
          && (p.fill === this.selectedValues.backgroundColor)
          && (p.stroke === this.selectedValues.strokeColor)
          && (p.strokeStyle === this.selectedValues.strokeStylePreset)
      })
    },
  },
  methods: {
    select (preset) { this.$emit('choose', preset) },
  },
}
</script>
